Index: /main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py
===================================================================
--- /main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py	(revision 14769)
+++ /main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py	(revision 14770)
@@ -52,17 +52,17 @@
     action = 'http://www.remitademo.net/remita/ecomm/finalize.reg'
 
-    @property
-    def lineitems(self):
-        ba1 = self.context.amount_auth / 2
-        ba2 = self.context.amount_auth / 2
-        lineitems = (
-                      {"lineItemsId":"itemid1","beneficiaryName":"Klaus Mueller",
-                      "beneficiaryAccount":"6020067886","bankCode":"011",
-                      "beneficiaryAmount":str(ba1),"deductFeeFrom":"1"},
-                      {"lineItemsId":"itemid2","beneficiaryName":"Werner Rumm",
-                      "beneficiaryAccount":"0360883515","bankCode":"050",
-                      "beneficiaryAmount":str(ba2),"deductFeeFrom":"0"}
-                    )
-        return lineitems
+    #@property
+    #def lineitems(self):
+    #    ba1 = self.context.amount_auth / 2
+    #    ba2 = self.context.amount_auth / 2
+    #    lineitems = (
+    #                  {"lineItemsId":"itemid1","beneficiaryName":"Klaus Mueller",
+    #                  "beneficiaryAccount":"6020067886","bankCode":"011",
+    #                  "beneficiaryAmount":str(ba1),"deductFeeFrom":"1"},
+    #                  {"lineItemsId":"itemid2","beneficiaryName":"Werner Rumm",
+    #                  "beneficiaryAccount":"0360883515","bankCode":"050",
+    #                  "beneficiaryAmount":str(ba2),"deductFeeFrom":"0"}
+    #                )
+    #    return lineitems
 
     def dynamic_provider_amt(self, student):
@@ -72,11 +72,11 @@
 
     @property
-    def xxx_lineitems(self):
+    def lineitems(self):
         provider_amt = 0.0
         if self.context.p_category == 'schoolfee' and \
             not self.context.p_item == 'Balance':
-            provider_amt = self.dynamic_provider_amt(self.student)
+            provider_amt = self.dynamic_provider_amt(self.context.student)
         elif self.context.p_category == 'clearance':
-            provider_amt = self.dynamic_provider_amt(self.student)
+            provider_amt = self.dynamic_provider_amt(self.context.student)
         inst_amt = self.context.amount_auth - provider_amt
         if provider_amt:
@@ -100,6 +100,4 @@
         if not module_activated(self.context.student.current_session):
             return
-        self.orderId = self.context.p_id
-        self.amount = str(self.context.amount_auth)
         error = self.init_update()
         if error:
@@ -107,4 +105,6 @@
             self.redirect(self.url(self.context, '@@index'))
             return
+        self.orderId = self.context.p_id
+        self.amount = str(self.context.amount_auth)
         return
 
@@ -136,14 +136,29 @@
     action = 'http://www.remitademo.net/remita/ecomm/finalize.reg'
 
+    #@property
+    #def lineitems(self):
+    #    lineitems = (
+    #                  {"lineItemsId":"itemid1","beneficiaryName":"Klaus Mueller",
+    #                  "beneficiaryAccount":"6020067886","bankCode":"011",
+    #                  "beneficiaryAmount":self.context.amount_auth/2,"deductFeeFrom":"1"},
+    #                  {"lineItemsId":"itemid2","beneficiaryName":"Werner Rumm",
+    #                  "beneficiaryAccount":"0360883515","bankCode":"050",
+    #                  "beneficiaryAmount":self.context.amount_auth/2,"deductFeeFrom":"0"}
+    #                )
+    #    return lineitems
+
     @property
     def lineitems(self):
-
+        provider_amt = 400.0
+        if self.context.__parent__.applicant_id.startswith('cbt'):
+            provider_amt = 200.0
+        inst_amt = self.context.amount_auth - provider_amt
         lineitems = (
-                      {"lineItemsId":"itemid1","beneficiaryName":"Klaus Mueller",
-                      "beneficiaryAccount":"6020067886","bankCode":"011",
-                      "beneficiaryAmount":self.context.amount_auth/2,"deductFeeFrom":"1"},
-                      {"lineItemsId":"itemid2","beneficiaryName":"Werner Rumm",
-                      "beneficiaryAccount":"0360883515","bankCode":"050",
-                      "beneficiaryAmount":self.context.amount_auth/2,"deductFeeFrom":"0"}
+                      {"lineItemsId":"itemid1","beneficiaryName":"Uniben",
+                      "beneficiaryAccount":"0040217361011","bankCode":"000",
+                      "beneficiaryAmount":inst_amt,"deductFeeFrom":"1"},
+                      {"lineItemsId":"itemid2","beneficiaryName":"WAeAC",
+                      "beneficiaryAccount":"1014261520","bankCode":"057",
+                      "beneficiaryAmount":provider_amt,"deductFeeFrom":"0"}
                     )
         return lineitems
@@ -152,6 +167,4 @@
         if not module_activated(self.context.__parent__.__parent__.year):
             return
-        self.orderId = self.context.p_id
-        self.amount = str(self.context.amount_auth)
         error = self.init_update()
         if error:
@@ -159,3 +172,5 @@
             self.redirect(self.url(self.context, '@@index'))
             return
+        self.orderId = self.context.p_id
+        self.amount = str(self.context.amount_auth)
         return