Index: /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py
===================================================================
--- /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py	(revision 14789)
+++ /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py	(revision 14790)
@@ -33,4 +33,7 @@
 from kofacustom.nigeria.remita.studentsbrowser import module_activated
 
+from kofacustom.nigeria.remita.tests import (
+    MERCHANTID, HOST, HTTPS, API_KEY, SERVICETYPEID)
+
 grok.templatedir('browser_templates')
 
@@ -99,8 +102,8 @@
 
     # Here we use Remita test portal data
-    merchantId = '2547916'
-    host = 'www.remitademo.net'
-    https = False
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
 
     def update(self):
@@ -152,8 +155,8 @@
 
     # Here we use Remita test portal data
-    merchantId = '2547916'
-    host = 'www.remitademo.net'
-    https = False
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
 
     def update(self):
@@ -206,12 +209,13 @@
     label = _('Pay via Remita')
     submit_button = _('Pay now')
-    https = False
 
     # Here we use Remita test portal data
-    merchantId = '2547916'
-    serviceTypeId = '4430731'
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+    serviceTypeId = SERVICETYPEID
+
     orderId = '3456346346'
-    host = 'www.remitademo.net'
     init_url = '/remita/ecomm/split/init.reg'
     amount='1000'
Index: /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py
===================================================================
--- /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py	(revision 14789)
+++ /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py	(revision 14790)
@@ -33,4 +33,7 @@
 from kofacustom.nigeria.interfaces import MessageFactory as _
 
+from kofacustom.nigeria.remita.tests import (
+    MERCHANTID, HOST, HTTPS, API_KEY, SERVICETYPEID)
+
 grok.templatedir('browser_templates')
 
@@ -107,8 +110,8 @@
 
     # Here we use Remita test portal data
-    merchantId = '2547916'
-    host = 'www.remitademo.net'
-    https = False
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
 
     def update(self):
@@ -160,8 +163,8 @@
 
     # Here we use Remita test portal data
-    merchantId = '2547916'
-    host = 'www.remitademo.net'
-    https = False
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
 
     def update(self):
@@ -214,12 +217,13 @@
     label = _('Pay via Remita')
     submit_button = _('Pay now')
-    https = False
 
     # Here we use Remita test portal data
-    merchantId = '2547916'
-    serviceTypeId = '4430731'
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+    serviceTypeId = SERVICETYPEID
+
     orderId = '3456346346'
-    host = 'www.remitademo.net'
     init_url = '/remita/ecomm/split/init.reg'
     amount='1000'
Index: /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/tests.py
===================================================================
--- /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/tests.py	(revision 14789)
+++ /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/tests.py	(revision 14790)
@@ -38,4 +38,10 @@
 EXTERNAL_TESTS = True
 
+MERCHANTID = '2547916'
+HOST = 'www.remitademo.net'
+HTTPS = False
+API_KEY = '1946'
+SERVICETYPEID = '4430731'
+
 def external_test(func):
     if not EXTERNAL_TESTS:
@@ -50,9 +56,12 @@
 class HelperTests(unittest.TestCase):
 
-    merchantId = '2547916'
-    serviceTypeId = '4430731'
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+    serviceTypeId = SERVICETYPEID
+
     responseurl = 'http://xxxx'
-    host = 'www.remitademo.net'
+
     url = '/remita/ecomm/split/init.reg'  # /remita/ecomm/v2/init.reg
     lineitems = (
@@ -72,5 +81,5 @@
                 api_key=self.api_key, orderId=self.orderId,
                 amount=self.amount, responseurl=self.responseurl,
-                host=self.host, url=self.url, https=False,
+                host=self.host, url=self.url, https=self.https,
                 fullname='Anton Meier', email='am@xxx.de',
                 lineitems=self.lineitems)
@@ -84,5 +93,5 @@
                 api_key=self.api_key, orderId=self.orderId,
                 amount=self.amount, responseurl=self.responseurl,
-                host=self.host, url=self.url, https=False,
+                host=self.host, url=self.url, https=self.https,
                 fullname='Anton Meier', email='am@xxx.de',
                 lineitems=self.lineitems)
@@ -99,5 +108,5 @@
                 RRR=self.rrr,
                 host=self.host,
-                https=False,
+                https=self.https,
                 )
         assert resp['orderId'] == self.orderId
@@ -116,9 +125,10 @@
     layer = FunctionalLayer
 
-    merchantId = '2547916'
-    serviceTypeId = '4430731'
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+
     responseurl = 'http://xxxx'
-    host = 'www.remitademo.net'
 
     # successful transaction
@@ -162,5 +172,5 @@
             RRR=self.rrr_p,
             host=self.host,
-            https=False,
+            https=self.https,
             verify=False)
         assert qr == (
@@ -179,5 +189,5 @@
             RRR=self.rrr,
             host=self.host,
-            https=False,
+            https=self.https,
             verify=False)
         assert qr[0] == True
@@ -232,9 +242,10 @@
     layer = FunctionalLayer
 
-    merchantId = '2547916'
-    serviceTypeId = '4430731'
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+
     responseurl = 'http://xxxx'
-    host = 'www.remitademo.net'
 
     # successful transaction
@@ -288,9 +299,10 @@
     layer = FunctionalLayer
 
-    merchantId = '2547916'
-    serviceTypeId = '4430731'
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+
     responseurl = 'http://xxxx'
-    host = 'www.remitademo.net'
 
     # successful transaction
Index: /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py
===================================================================
--- /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py	(revision 14789)
+++ /main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py	(revision 14790)
@@ -33,5 +33,5 @@
     grok.require('waeup.Public')
 
-    ACCEPTED_IP = None
+    ACCEPTED_IP = ('127.0.0.1',)
 
     # Here we use Remita test portal data