Index: main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py	(revision 14791)
+++ main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py	(revision 14792)
@@ -20,8 +20,17 @@
     module_activated,
     RemitaRequestPaymentStatusPageStudent,
+    RemitaVerifyPaymentStatusPageStudent,
     RemitaPageStudent)
 from kofacustom.nigeria.remita.applicantsbrowser import (
     RemitaRequestPaymentStatusPageApplicant,
+    RemitaVerifyPaymentStatusPageApplicant,
     RemitaPageApplicant)
+
+# Temporarily we can use the test portal like in kofacustom.nigeria
+MERCHANTID = '2547916'
+HOST = 'www.remitademo.net'
+HTTPS = False
+API_KEY = '1946'
+SERVICETYPEID = '4430731'
 
 class CustomRemitaRequestPaymentStatusPageStudent(
@@ -30,9 +39,19 @@
     """
 
-    # Here we use Remita test portal data
-    merchantId = '2547916'
-    host = 'www.remitademo.net'
-    https = False
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+    serviceTypeId = SERVICETYPEID
+
+class CustomRemitaVerifyPaymentStatusPageStudent(
+    RemitaVerifyPaymentStatusPageStudent):
+    """ Request webservice view for the Remita gateway.
+    """
+
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
 
 class CustomRemitaPageStudent(RemitaPageStudent):
@@ -40,14 +59,11 @@
     """
 
-    # Here we use Remita test portal data
-    merchantId = '2547916'
-    serviceTypeId = '4430731'
-    api_key = '1946'
-    #orderId = '3456346346'
-    host = 'www.remitademo.net'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+    serviceTypeId = SERVICETYPEID
+
     init_url = '/remita/ecomm/split/init.reg'
-    #amount='1000'
-    https = False
-
     action = 'http://www.remitademo.net/remita/ecomm/finalize.reg'
 
@@ -114,9 +130,19 @@
     """
 
-    # Here we use Remita test portal data
-    merchantId = '2547916'
-    host = 'www.remitademo.net'
-    https = False
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+    serviceTypeId = SERVICETYPEID
+
+class CustomRemitaVerifyPaymentStatusPageApplicant(
+    RemitaVerifyPaymentStatusPageApplicant):
+    """ Request webservice view for the Remita gateway.
+    """
+
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
 
 class CustomRemitaPageApplicant(RemitaPageApplicant):
@@ -124,14 +150,11 @@
     """
 
-    # Here we use Remita test portal data
-    merchantId = '2547916'
-    serviceTypeId = '4430731'
-    api_key = '1946'
-    #orderId = '3456346346'
-    host = 'www.remitademo.net'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY
+    serviceTypeId = SERVICETYPEID
+
     init_url = '/remita/ecomm/split/init.reg'
-    #amount='1000'
-    https = False
-
     action = 'http://www.remitademo.net/remita/ecomm/finalize.reg'
 
Index: main/waeup.uniben/trunk/src/waeup/uniben/remita/webservices.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/remita/webservices.py	(revision 14791)
+++ main/waeup.uniben/trunk/src/waeup/uniben/remita/webservices.py	(revision 14792)
@@ -18,6 +18,8 @@
 
 from kofacustom.nigeria.remita.webservices import PaymentNotificationListenerWebservice
+from waeup.uniben.remita.browser import MERCHANTID, HOST, HTTPS, API_KEY
 
-class CustomPaymentNotificationListenerWebservice(PaymentNotificationListenerWebservice):
+class CustomPaymentNotificationListenerWebservice(
+    PaymentNotificationListenerWebservice):
     """A webservice to receive payment notifications from
     accepted IP addresses without authentication which trigger
@@ -28,7 +30,6 @@
                    '162.13.211.92', '83.138.167.2',)
 
-    # We temporarily use Remita test portal data
-    merchantId = '2547916'
-    host = 'www.remitademo.net'
-    https = False
-    api_key = '1946'
+    merchantId = MERCHANTID
+    host = HOST
+    https = HTTPS
+    api_key = API_KEY