Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/applicant.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/applicant.py	(revision 14824)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/applicant.py	(revision 14829)
@@ -38,4 +38,8 @@
         ('alr_date', 'alr_date'),
         ('alr_results', 'alr_results'),
+        ('fst_sit_sc_pin', 'fst_sit_sc_pin'),
+        ('fst_sit_sc_serial_number', 'fst_sit_sc_serial_number'),
+        ('scd_sit_sc_pin', 'scd_sit_sc_pin'),
+        ('scd_sit_sc_serial_number', 'scd_sit_sc_serial_number'),
         #('', ''),
         ]
Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py	(revision 14824)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/interfaces.py	(revision 14829)
@@ -71,4 +71,5 @@
         required = True,
         )
+
     lga = schema.Choice(
         source = LGASource(),
@@ -76,24 +77,30 @@
         required = False,
         )
+
     perm_address = schema.Text(
         title = _(u'Permanent Address'),
         required = False,
         )
+
     home_town = schema.TextLine(
         title = _(u'Home Town'),
         required = False,
         )
+
     #jamb_reg_number = schema.TextLine(
     #    title = _(u'JAMB Registration Number'),
     #    required = False,
     #    )
+
     jamb_score = schema.Int(
         title = _(u'Total JAMB Score'),
         required = False,
         )
+
     jamb_subjects = schema.Text(
         title = _(u'JAMB Subjects and Scores'),
         required = False,
         )
+
     course1 = schema.Choice(
         title = _(u'1st Choice Course of Study'),
@@ -101,4 +108,5 @@
         required = False,
         )
+
     course2 = schema.Choice(
         title = _(u'2nd Choice Course of Study'),
@@ -106,4 +114,5 @@
         required = False,
         )
+
     fst_sit_fname = schema.TextLine(
         title = _(u'Full Name'),
@@ -111,4 +120,5 @@
         readonly = False,
         )
+
     fst_sit_no = schema.TextLine(
         title = _(u'Exam Number'),
@@ -116,4 +126,17 @@
         readonly = False,
         )
+
+    fst_sit_sc_pin = schema.TextLine(
+        title = _(u'Scratch Card Pin'),
+        required = False,
+        readonly = False,
+        )
+
+    fst_sit_sc_serial_number = schema.TextLine(
+        title = _(u'Scratch Card Serial Number'),
+        required = False,
+        readonly = False,
+        )
+
     fst_sit_date = FormattedDate(
         title = _(u'Exam Date'),
@@ -122,4 +145,5 @@
         show_year = True,
         )
+
     fst_sit_type = schema.Choice(
         title = _(u'Exam Type'),
@@ -128,4 +152,5 @@
         vocabulary = exam_types,
         )
+
     fst_sit_results = schema.List(
         title = _(u'Exam Results'),
@@ -135,4 +160,5 @@
         defaultFactory=list,
         )
+
     scd_sit_fname = schema.TextLine(
         title = _(u'Full Name'),
@@ -140,4 +166,5 @@
         readonly = False,
         )
+
     scd_sit_no = schema.TextLine(
         title = _(u'Exam Number'),
@@ -145,4 +172,17 @@
         readonly = False,
         )
+
+    scd_sit_sc_pin = schema.TextLine(
+        title = _(u'Scratch Card Pin'),
+        required = False,
+        readonly = False,
+        )
+
+    scd_sit_sc_serial_number = schema.TextLine(
+        title = _(u'Scratch Card Serial Number'),
+        required = False,
+        readonly = False,
+        )
+
     scd_sit_date = FormattedDate(
         title = _(u'Exam Date'),
@@ -151,4 +191,5 @@
         show_year = True,
         )
+
     scd_sit_type = schema.Choice(
         title = _(u'Exam Type'),
@@ -157,4 +198,5 @@
         vocabulary = exam_types,
         )
+
     scd_sit_results = schema.List(
         title = _(u'Exam Results'),
@@ -164,4 +206,5 @@
         defaultFactory=list,
         )
+
     alr_fname = schema.TextLine(
         title = _(u'Full Name'),
@@ -169,4 +212,5 @@
         readonly = False,
         )
+
     alr_no = schema.TextLine(
         title = _(u'Exam Number'),
@@ -174,4 +218,5 @@
         readonly = False,
         )
+
     alr_date = FormattedDate(
         title = _(u'Exam Date'),
@@ -180,4 +225,5 @@
         show_year = True,
         )
+
     alr_results = schema.List(
         title = _(u'Exam Results'),
@@ -187,4 +233,5 @@
         defaultFactory=list,
         )
+
     hq_type = schema.Choice(
         title = _(u'Qualification Obtained'),
@@ -787,8 +834,58 @@
         )
 
+    fst_sit_fname = schema.TextLine(
+        title = _(u'Full Name'),
+        required = True,
+        readonly = False,
+        )
+
+    fst_sit_no = schema.TextLine(
+        title = _(u'Exam Number'),
+        required = True,
+        readonly = False,
+        )
+
+    fst_sit_sc_pin = schema.TextLine(
+        title = _(u'Scratch Card Pin'),
+        required = True,
+        readonly = False,
+        )
+
+    fst_sit_sc_serial_number = schema.TextLine(
+        title = _(u'Scratch Card Serial Number'),
+        required = True,
+        readonly = False,
+        )
+
+    fst_sit_date = FormattedDate(
+        title = _(u'Exam Date'),
+        required = True,
+        readonly = False,
+        show_year = True,
+        )
+
+    fst_sit_type = schema.Choice(
+        title = _(u'Exam Type'),
+        required = True,
+        readonly = False,
+        vocabulary = exam_types,
+        )
+
 #ICustomUGApplicantEdit['programme_type'].order = ICustomUGApplicant[
 #    'programme_type'].order
 ICustomUGApplicantEdit['date_of_birth'].order = ICustomUGApplicant[
     'date_of_birth'].order
+ICustomUGApplicantEdit['fst_sit_fname'].order = ICustomUGApplicant[
+    'fst_sit_fname'].order
+ICustomUGApplicantEdit['fst_sit_no'].order = ICustomUGApplicant[
+    'fst_sit_no'].order
+ICustomUGApplicantEdit['fst_sit_sc_pin'].order = ICustomUGApplicant[
+    'fst_sit_sc_pin'].order
+ICustomUGApplicantEdit['fst_sit_sc_serial_number'].order = ICustomUGApplicant[
+    'fst_sit_sc_serial_number'].order
+ICustomUGApplicantEdit['fst_sit_date'].order = ICustomUGApplicant[
+    'fst_sit_date'].order
+ICustomUGApplicantEdit['fst_sit_type'].order = ICustomUGApplicant[
+    'fst_sit_type'].order
 
 class ICustomPGApplicantEdit(INigeriaPGApplicantEdit):
Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py	(revision 14824)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py	(revision 14829)
@@ -66,4 +66,10 @@
         self.browser.getControl(name="form.sex").value = ['m']
         self.browser.getControl(name="form.lastname").value = 'Merkel'
+        self.browser.getControl(name="form.fst_sit_fname").value = 'name'
+        self.browser.getControl(name="form.fst_sit_no").value = 'no'
+        self.browser.getControl(name="form.fst_sit_sc_pin").value = 'pin'
+        self.browser.getControl(name="form.fst_sit_sc_serial_number").value = 'serial'
+        self.browser.getControl(name="form.fst_sit_date").value = '09/09/2000'
+        self.browser.getControl(name="form.fst_sit_type").value = ['ssce']
         self.browser.getControl("Save").click()
         self.browser.getControl("Add online payment ticket").click()