Index: main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 14856)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 14857)
@@ -600,32 +600,33 @@
         # In Uniben students can pay school fee in all states no matter
         # if they are ug or pg students.
-        IWorkflowState(self.student).setState('school fee paid')
-        self.student.is_staff = False
-        self.student.nationality = u'NG'
-        self.certificate.school_fee_2 = 10000.0
-        error, payment = utils.setPaymentDetails(
-            'schoolfee', self.student, None, None)
-        self.assertEqual(payment.p_level, None)
-        self.assertEqual(payment.p_session, 2005)
-        self.assertEqual(payment.amount_auth, 10088.0)
-        self.assertEqual(payment.p_item, u'CERT1')
-        self.assertEqual(error, None)
-        IWorkflowState(self.student).setState('courses registered')
-        self.certificate.study_mode = 'special_pg_pt'
-        error, payment = utils.setPaymentDetails(
-            'schoolfee', self.student, None, None)
-        self.assertEqual(payment.p_level, None)
-        self.assertEqual(payment.p_session, 2005)
-        self.assertEqual(payment.amount_auth, 10000.0)
-        self.assertEqual(payment.p_item, u'CERT1')
-        self.assertEqual(error, None)
-        IWorkflowState(self.student).setState('courses validated')
-        error, payment = utils.setPaymentDetails(
-            'schoolfee', self.student, None, None)
-        self.assertEqual(payment.p_level, None)
-        self.assertEqual(payment.p_session, 2005)
-        self.assertEqual(payment.amount_auth, 10000.0)
-        self.assertEqual(payment.p_item, u'CERT1')
-        self.assertEqual(error, None)
+        # diabled on 02/10/2017, see ticket 1108
+        #IWorkflowState(self.student).setState('school fee paid')
+        #self.student.is_staff = False
+        #self.student.nationality = u'NG'
+        #self.certificate.school_fee_2 = 10000.0
+        #error, payment = utils.setPaymentDetails(
+        #    'schoolfee', self.student, None, None)
+        #self.assertEqual(payment.p_level, None)
+        #self.assertEqual(payment.p_session, 2005)
+        #self.assertEqual(payment.amount_auth, 10088.0)
+        #self.assertEqual(payment.p_item, u'CERT1')
+        #self.assertEqual(error, None)
+        #IWorkflowState(self.student).setState('courses registered')
+        #self.certificate.study_mode = 'special_pg_pt'
+        #error, payment = utils.setPaymentDetails(
+        #    'schoolfee', self.student, None, None)
+        #self.assertEqual(payment.p_level, None)
+        #self.assertEqual(payment.p_session, 2005)
+        #self.assertEqual(payment.amount_auth, 10000.0)
+        #self.assertEqual(payment.p_item, u'CERT1')
+        #self.assertEqual(error, None)
+        #IWorkflowState(self.student).setState('courses validated')
+        #error, payment = utils.setPaymentDetails(
+        #    'schoolfee', self.student, None, None)
+        #self.assertEqual(payment.p_level, None)
+        #self.assertEqual(payment.p_session, 2005)
+        #self.assertEqual(payment.amount_auth, 10000.0)
+        #self.assertEqual(payment.p_item, u'CERT1')
+        #self.assertEqual(error, None)
 
         error, payment = utils.setPaymentDetails('clearance',
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py	(revision 14856)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py	(revision 14857)
@@ -310,5 +310,7 @@
                     else:
                         amount = getattr(certificate, 'school_fee_1', 0.0)
-                elif student.state in (PAID, REGISTERED, VALIDATED):
+                elif False:
+                # diabled on 02/10/2017, see ticket 1108
+                #elif student.state in (PAID, REGISTERED, VALIDATED):
                     p_session += 1
                     # We don't know which level the student is paying for.